'' File: "Rc Decay.spin"

'' For repeated RC decay measurements taken by a separate cog,
'' call the start method.

'' For a single RC decay measureent, call Decay directly.

VAR

  long cog, stack[30]

PUB start(pin, address) : okay

  '' Starts a cog that takes repeated measurements on pin and
  '' stores them in the variable at address.

  okay := cog := cognew(AutoUpdater(pin, address), @stack) + 1

PUB stop

  '' Stops (and frees) the cog.

  if cog
    cogstop(cog~ - 1)

PRI AutoUpdater(pin, address)

  repeat
    long[address] := Decay(pin)

PUB Decay(pin) : time

  '' Takes an RC Decay measurement at pin and returns time in
  '' clock ticks.

  outa[pin]~~
  dira[pin]~~
  ctra[30..26] := %01000
  ctra[8..0] := pin
  frqa := 1
  phsa~
  dira[pin]~
  waitpeq(0, |< pin, 0)
  time := phsa - 640
